##############################################################################
#
# Setup local macros and/or make variables.  These are settings that are
# specific to a given project and especially the site.  This file should
# be edited to match your needs.
#
# You can save this file in a permanent place and the configure script
# will copy it into the build directory automatically.  It checks first in
# ${configdir} if it exists, then in ~/config.  This is a truly painless
# way to maintain the code on multiple platforms.  Note: settings that
# hold for an entire class of machines should be put in the appropriate
# system config file, rather than here.
#
# $Id: cf_plplot.m4,v 1.11 1994/05/24 19:54:08 mjl Exp $
#
##############################################################################

# Directories, libraries, and other settings.
# PLDEVICES should be redefined as appropriate in your system config file.
# Final determination of library names are made later (since the config file
# might specify a shared library).

# INSTALL_DIR can be set in GNU autoconf style using configure, i.e.
# "configure --prefix=/usr/local/plplot5.0".  This value (as set by
# configure) will override any value set in the makefile.

INSTALL_DIR	= /usr/local/plplot
TK_INCDIR	= /usr/local/{include}

dnl> Enable X or TK drivers
dnl> Uncomment those you wish enabled for your system.  These require:
dnl>
dnl>    XWIN	X-windows
dnl>    TK	X-windows, Tcl/TK
dnl>    DP	X-windows, Tcl/TK, Tcl-DP
dnl>    ITCL	X-windows, Tcl/TK, [incr Tcl]
dnl>
dnl> These are all great packages, and you should try to get them all,
dnl> especially if you want the full use of PLplot capabilities.  Only the
dnl> xwin driver is the default since it is a fair common denominator.  On
dnl> sites where you have the others, install this file as outlined above.

define({XWIN},)
# define({TK},)
# define({DP},)
# define({ITCL},)

dnl> NOTE! You should not have any of DEF_TK, DEF_XWIN, or DEF_DP defined.
dnl> These are defined elsewhere now.

PLDEVICES = -DPLMETA -DNULLDEV -DXTERM -DTEK4010 -DTEK4107 \
	    -DMSKERMIT -DVLT -DVERSATERM \
	    -DDG300 -DPS -DXFIG -DLJII -DHP7470 -DHP7580 \
	    -DIMP DEF_XWIN() DEF_TK() DEF_DP()

# This can be used to find the X11 or any other header files.  One nice way
# to do this is to soft link the X11 include directory in your ~/include
# directory (i.e. make a directory ~/include/X11).  

#INC_DIR_C	=
INC_DIR_C	= -I$(HOME)/{include} -I$(TK_INCDIR)

# These are used to find the libraries we are linking with.

LDC_PATH	= -L/usr/local/lib
LDCXX_PATH	= -L/usr/local/lib
LDF_PATH	= -L/usr/local/lib

# Any site-specific flags or libraries required go here.

EXT_FLAGS_C	=
EXT_FLAGS_CXX	=
EXT_FLAGS_F	=
EXT_FLAGS_LC	=
EXT_FLAGS_LCXX	=
EXT_FLAGS_LF	=

EXT_LIBS_C	=
EXT_LIBS_CXX	=
EXT_LIBS_F	=
